using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SharpProxyService
{
    public partial class MyForm : Form
    {
        public MyForm()
        {
            InitializeComponent();
        }

        private void tableLayoutPanel1_Paint(object sender, PaintEventArgs e)
        {
            
        }

        private void MyForm_Load(object sender, EventArgs e)
        {
            dataGridView1.DataSource = PortMapper.MyConfig.CFG;
            RefreshIt();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            RefreshIt();
        }

        void RefreshIt() 
        {
            textBox1.Clear();
            StringBuilder SB = new StringBuilder();
            
            lock (PortMapper.MyConfig.TheMaps) 
            {

                foreach (Mapping M in PortMapper.MyConfig.TheMaps) 
                {
                    if (!M.Disposed)
                    {
                        SB.Append("On local " + M.LocalSocket.LocalEndPoint.ToString() + " to remote " + M.RemoteEP.ToString() + " clients are:\r\n");
                        foreach (Exchange E in M.Exchanging)
                        {
                            if (!E.Disposed)
                            {
                                SB.Append(E.RemoteClientSocket.RemoteEndPoint.ToString() + "\r\n");
                            }
                        }
                        SB.Append("\r\n");
                    }
                }
            
            }
            textBox1.Text = SB.ToString();

        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Will reset all current connections, continue?", "Warning", MessageBoxButtons.OKCancel).ToString().Equals("OK")) 
            {
                PortMapper.MyConfig.SaveCfg();
                PortMapper.MyConfig.ApplySettings();
            }
            RefreshIt();
        }
    }
}