using System;
using System.Collections.Generic;
using System.Text;

namespace SharpProxyService
{
    public class SamplePlugin:SharpProxyPlugin 
    {
        public SamplePlugin() 
        { 
            //default constructor
        }

        PluginVoidResult DoNothing = new PluginVoidResult(); // - result that affects nothing
        public static Config MyConfig; // my config to use
        ConfigForm TheForm;//the mdi child form for user change settings

        //the first call
        //from here we can see who has loaded with us - in this plugin it does not matter
        //but its important, for example, to ACL plugins to have it AUTHORIZATOR pair
        public override void OnPlug(List<SharpProxyPlugin> TheAllLoadedPlugins){}

        //the second call
        //CWD - e.g. c:\sharpproxy
        //we have to load our settings or set defaults
        public override void LoadPluginSettings(string CWD)
        {
            MyConfig = new Config(CWD + "\\" + this.PluginName + ".settings");
            MyConfig.LoadOrSetDefaults();
        }
        //we need just this "event"
        public override PluginVoidResult OnNewProxyRequestBuild(ProxyRequest CurrentProxyRequest)
        {
            if (CurrentProxyRequest.HeadersFields.ContainsKey("USER-AGENT:"))
            {
                //CurrentProxyRequest.ExtraLogData - the data for loggers. If you want to came some data to become log able - write it here
                CurrentProxyRequest.ExtraLogData.Add("OLD USER-AGENT:", (string)CurrentProxyRequest.HeadersFields["USER-AGENT:"]);
                CurrentProxyRequest.HeadersFields["USER-AGENT:"] = MyConfig.UserAgent;

            }
            else 
            {
                CurrentProxyRequest.HeadersFields.Add("USER-AGENT:", MyConfig.UserAgent);
                CurrentProxyRequest.ExtraLogData.Add("OLD USER-AGENT:", "WAS NOT SET");
            }
            return DoNothing;
        }


        public override void AfterProxyRequestDisposed(ProxyRequest DisposedRequest){}
        public override void AfterServerDisconnected(ProxyRequest CurrentRequest){}
        public override PluginVoidResult BeforeSendDataToClient(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }
        public override PluginVoidResult BeforeSendDataToServer(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }
        public override PluginVoidResult OnClientConnected(System.Net.Sockets.Socket ClientSocket)
        {
            return DoNothing;
        }
        public override PluginVoidResult OnClientDataArrived(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }
        public override void OnClientDisconnected(System.Net.Sockets.Socket ClientSocket)
        {
            
        }
        public override PluginVoidResult OnFtpDataArrived(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }

        public override PluginVoidResult OnProxyRequestDisposing(ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }
        public override PluginVoidResult OnServerDataArrived(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }
        public override void OnUnPlug(UnplugReason TheReason)
        {
            MyConfig = null;
            if (TheForm != null) 
            {
                try
                {
                    TheForm.Dispose();
                }
                catch { }
            }
        }
        public override string PluginName
        {
            get { return "My Sample Plugin"; }
        }
        public override System.Collections.Hashtable PluginSettings
        {
            get { return null; }
        }
        public override int PluginVersion
        {
            get { return 1; }
        }
        public override void Show_Setting_For_User_To_Edit(System.Windows.Forms.Form TheMDIParent_Form)
        {
            if (TheForm != null)
            {
                try
                {
                    TheForm.Dispose();
                }
                catch { }
            }
            //we call every time new form because,possible, user did smth in older form
            //and don't know how cancel the changes 
            //every plugin I've wrotten did this, but its your business which way to choose
            TheForm = new ConfigForm();
            TheForm.MdiParent = TheMDIParent_Form;
            TheForm.Visible = true;
            TheForm.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            
        }
        public override PluginType TheType
        {
            get { return PluginType.EXTRA_FUNCTIONS ; }
        }
    }
}
