using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace SharpProxyService
{
    public class Config
    {
        string FileName; //  - file to store our config
        string Ua; // the user agent to write
        public Config(string _FileName) 
        {
            FileName = _FileName;
        }
        public string UserAgent 
        {
            get { return Ua; }
            set { Ua = value; }
        
        }
        public void LoadOrSetDefaults() 
        {
            if (File.Exists(FileName))
            {
                try
                {
                    Ua = File.ReadAllText(FileName);
                }
                catch { Ua = "It was error on reading " + FileName; }
            }
            else 
            {
                Ua = "Set UA here";
                Save();
            }
        }

        public void Save() 
        {
            try
            {
                File.WriteAllText(FileName, Ua);
            }
            catch { }
        }
    }
}
